Introduce BootUnfolding, set when unfolding is absent due to hs-boot file.
ClosedPublic

Authored by ezyang on May 20 2016, 2:47 PM.

Details

Summary

Signed-off-by: Edward Z. Yang <ezyang@cs.stanford.edu>

Test Plan

validate

Diff Detail

Repository
rGHC Glasgow Haskell Compiler
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.
ezyang retitled this revision from to Introduce BootUnfolding, set when unfolding is absent due to hs-boot file..May 20 2016, 2:47 PM
ezyang edited the test plan for this revision. (Show Details)
ezyang added a reviewer: simonpj.
ezyang updated this object.
austin accepted this revision.May 20 2016, 3:25 PM

LGTM, I like code reduction.

This revision is now accepted and ready to land.May 20 2016, 3:25 PM
simonpj accepted this revision.May 20 2016, 4:04 PM

Yes, but needs a big Note!!

compiler/coreSyn/CoreSyn.hs
981

Yes, but it needs a massive Note to explain what is going on here. Why do we need to track boot unfoldings?!!! It's to make us add a 'noinline' at some critical moment (I've already forgotten where exactly). But why? Point to the ticket of course, but a standalone explanation is needed.

1276

Never called?

ezyang added inline comments.May 21 2016, 3:32 AM
compiler/coreSyn/CoreSyn.hs
981

I split the commit into two parts, one for adding BootUnfolding and another for using it; the Note will be in the next commit.

bgamari requested changes to this revision.Jun 3 2016, 3:35 PM

The problem with this is that it will fail validation due to unused bindings. What do you want to do about this, @ezyang?

This revision now requires changes to proceed.Jun 3 2016, 3:35 PM
This revision was automatically updated to reflect the committed changes.